JUCE: ReadWriteLock Class Reference

JUCE

Public Member Functions | List of all members
ReadWriteLock Class Reference
juce_core » threads

A critical section that allows multiple simultaneous readers. More...

`#include <juce_ReadWriteLock.h>`

## Public Member Functions
| ReadWriteLock () noexcept
| Creates a ReadWriteLock object. More...
| ~ReadWriteLock () noexcept
| Destructor. More...
void | enterRead () const noexcept
| Locks this object for reading. More...
bool | tryEnterRead () const noexcept
| Tries to lock this object for reading. More...
void | exitRead () const noexcept
| Releases the read-lock. More...
void | enterWrite () const noexcept
| Locks this object for writing. More...
bool | tryEnterWrite () const noexcept
| Tries to lock this object for writing. More...
void | exitWrite () const noexcept
| Releases the write-lock. More...

## Detailed Description

A critical section that allows multiple simultaneous readers.

Features of this type of lock are:

- Multiple readers can hold the lock at the same time, but only one writer can hold it at once.
- Writers trying to gain the lock will be blocked until all readers and writers have released it
- Readers trying to gain the lock while a writer is waiting to acquire it will be blocked until the writer has obtained and released it
- If a thread already has a read lock and tries to obtain a write lock, it will succeed if there are no other readers
- If a thread already has the write lock and tries to obtain a read lock, this will succeed.
- Recursive locking is supported.

See also
  ScopedReadLock, ScopedWriteLock, CriticalSection

## Constructor & Destructor Documentation

## ◆ ReadWriteLock()

ReadWriteLock::ReadWriteLock | ( |  | ) |
| noexcept

Creates a ReadWriteLock object.

## ◆ ~ReadWriteLock()

ReadWriteLock::~ReadWriteLock | ( |  | ) |
| noexcept

Destructor.

If the object is deleted whilst locked, any subsequent behaviour is undefined.

## Member Function Documentation

## ◆ enterRead()

void ReadWriteLock::enterRead | ( |  | ) | const
| noexcept

Locks this object for reading.

Multiple threads can simultaneously lock the object for reading, but if another thread has it locked for writing, then this will block until it releases the lock.

See also
  exitRead, ScopedReadLock

## ◆ tryEnterRead()

bool ReadWriteLock::tryEnterRead | ( |  | ) | const
| noexcept

Tries to lock this object for reading.

Multiple threads can simultaneously lock the object for reading, but if another thread has it locked for writing, then this will fail and return false.

Returns
  true if the lock is successfully gained.

See also
  exitRead, ScopedTryReadLock

## ◆ exitRead()

void ReadWriteLock::exitRead | ( |  | ) | const
| noexcept

Releases the read-lock.

If the caller thread hasn't got the lock, this can have unpredictable results.

If the enterRead() method has been called multiple times by the thread, each call must be matched by a call to exitRead() before other threads will be allowed to take over the lock.

See also
  enterRead, ScopedReadLock

## ◆ enterWrite()

void ReadWriteLock::enterWrite | ( |  | ) | const
| noexcept

Locks this object for writing.

This will block until any other threads that have it locked for reading or writing have released their lock.

See also
  exitWrite, ScopedWriteLock

## ◆ tryEnterWrite()

bool ReadWriteLock::tryEnterWrite | ( |  | ) | const
| noexcept

Tries to lock this object for writing.

This is like enterWrite(), but doesn't block - it returns true if it manages to obtain the lock.

Returns
  true if the lock is successfully gained.

See also
  enterWrite, ScopedTryWriteLock

## ◆ exitWrite()

void ReadWriteLock::exitWrite | ( |  | ) | const
| noexcept

Releases the write-lock.

If the caller thread hasn't got the lock, this can have unpredictable results.

If the enterWrite() method has been called multiple times by the thread, each call must be matched by a call to exit() before other threads will be allowed to take over the lock.

See also
  enterWrite, ScopedWriteLock

The documentation for this class was generated from the following file:

- juce_ReadWriteLock.h